# SIS Frontened Utilities

## About This Package

### What is this package?

This package is a collection of generic functions for converting, mutating, formatting, and validating data.

## Sections

Note: This package has only been tested with typescript. if you're using javascript, use at your own risk

-   [Convert](#convert)
-   [Mutate](#mutate)
-   [Format](#format)
-   [Guard](#guard)

---

## Convert --coming soon

### ExtractDate

#### Params

-   A string to get the date object from
-   The format of your string (ex : "MM-DD-YYYY hh:mm:ss")

#### Example usage

    ```
    import {Convert} from "@scheels-softdev/frontend-utility-functions"
    Convert.ExtractDate("03-05-2021", "DD-MM-YYYY") //returns a date object for May 3rd, 2021
    Convert.ExtractDate("03-05-2021", "MM-DD-YYYY") //returns a date object for March 5th, 2021
    ```

---

## Mutate

    Functions that edit a passed element without doing any type conversions

### ConcatenateKeys

#### Params

-   An object of type T, (ex: {firstName: "John", lastName: "Doe", result:""})
-   An array of keys of T to read from. (ex: ["firstName","lastName"] to have "John Doe")
-   A key of T to store the result in. (ex: "result" to return the following object: {firstName: "John", lastName: "Doe", result:"John Doe"})
-   An optional string to separate your concatenated values by. (ex: " - " to see "John - Doe" instead of "John Doe")

#### Example usage

    ```
    import {Mutate} from "@scheels-softdev/frontend-utility-functions"
    Mutate.ConcatenateKeys({firstName: "John", lastName: "Doe", result:"" }, ["lastName","firstName"], "result", " - ")
    // returns the following object: {firstName: "John", lastName: "Doe", result:"Doe - John"}
    ```

---

## Format

### PhoneNumber

#### Params

-   Takes in a string or number, assuming that this has already been validated to ensure it's in a valid format

#### Example usage:

    ```
    import {Format} from "@scheels-softdev/frontend-utility-functions"
    Format.PhoneNumber(1234567890)
    Format.PhoneNumber("1234567890")
    Format.PhoneNumber("123.456.7890")
    Format.PhoneNumber("123,456,7890")
    Format.PhoneNumber("(123)4567890")
    Format.PhoneNumber("123-456-7890")
    Format.PhoneNumber("(123)456-7890")
    // all return the following string: "(123)456-7890"
    ```

---

## Guard --coming soon

### There are implementations, but they aren't documented yet.
