/**
 * Formats the given string or number into a phone number string
 * @param {string | number} data - the data you want to format, this can be a string or number
 * @returns {string} - returns a string formatted to: (123) 456-7890
 */
export function PhoneNumber(data) {
    const cleaned = String(data).replace(/\D/g, "");
    const match = cleaned.match(/^(\d{3})(\d{3})(\d{4})$/);
    if (match) {
        return "(" + match[1] + ") " + match[2] + "-" + match[3];
    }
}
